import type { GetServerSideProps, NextPage } from "next";
import Head from "next/head";
import BlogItem, { BlogItemType } from "../components/BlogItem";
import PageTitle from "../components/PageTitle";
import ProductItem, { ProductItemType } from "../components/ProductItem";

interface Props {
  blogs: BlogItemType[]
  products: ProductItemType[]
}

const Search: NextPage<Props> = ({ blogs, products }) => {

  return (
    <>
      <Head>
        <title>Store - Search</title>
        <meta name="description" content="Generated by create next app" />
        <link rel="icon" href="/favicon.ico" />
      </Head>

      <PageTitle title="Search" />

      <div className="bg0 m-t-23 p-b-140 mt-5">
        <div className="container">
          {/* blogs  */}
          <>
            <h2 className="mb-5">Blogs</h2>
            <div className="row isotope-grid">
              {/* blog skeleton - search result */}
              <div className="col col-md-4">
                {blogs.length ? blogs.map(b => <BlogItem item={b} key={b.id} />) : <p>Haven`t blogs for this search</p>}
              </div>
              {/* !! */}
            </div>
          </>

          {/* products */}
          <>
            <h2 className="mb-5">Products</h2>
            <div className="row isotope-grid">
              {/* product skeleton */}
              {products.length ? products.map(i => <ProductItem id={i.id} key={i.id} img={i.img} price={i.price} title={i.title} />)
                : <p>Haven`t products for this search</p>}
              {/* <ProductItem /> */}
              {/* !! */}
            </div>
          </>
        </div>
      </div>
    </>
  );
};

export const getServerSideProps: GetServerSideProps = async ({ query }) => {
  console.log(query)

  const blogsRes = await fetch(`https://boutique-server-api.herokuapp.com/blogs?q=${query.search}`)
  const blogs = await blogsRes.json()

  const productsRes = await fetch(`https://boutique-server-api.herokuapp.com/products?q=${query.search}`)
  const products = await productsRes.json()


  return {
    props: {
      blogs,
      products,
    }
  }
}

export default Search;
